/*
TASK: depth
LANG: C++
ID: Nikolay Hubanov
*/

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct point
{
 int x,y,ind;
 point() {}
 point(int _x,int _y,int _ind) {x=_x;y=_y;ind=_ind;}
};

bool comp(point a,point b)
{
 return a.x<b.x || (a.x==b.x && a.y<b.y);
}

vector<point> inp,work;
point p;
bool found=false;
int n,k,ind;
bool used[10001];
int depth=-1;

int S(point &a,point &b,point &c)
{
 return (a.x-b.x)*(a.y+b.y)+(b.x-c.x)*(b.y+c.y)+(c.x-a.x)*(c.y+a.y);
}

bool same(point &a,point &b)
{
 return a.x==b.x && a.y==b.y;
}

void init()
{
 int x,y;
 scanf("%d",&n);
 for(int i=0;i<n;i++)
    {
     scanf("%d %d",&x,&y);
     inp.push_back(point(x,y,0));    
    }
 scanf("%d",&k);
 
 p=inp[k-1];
 sort(inp.begin(),inp.end(),comp);
 
 for(int i=0;i<n;i++)
    { inp[i].ind=i;
      if(same(inp[i],p)) ind=i;
    }
 work=inp;
}

void convexHull()
{
 vector<point> res;
 int t,p=0;
 depth++;
 int to=inp.size();
 if(to==1) {found=1;return;}
 for(int i=0;i<to;i++)
  {
   while(p>=2 && S( res[p-2],res[p-1],inp[i] )>0) {p--; res.pop_back();}
   p++;
   res.push_back(inp[i]);
  }
 
 t=p;
 for(int i=to-2;i>=0;i--)
   {
    while(p>t && S( res[p-2],res[p-1],inp[i] )>0) {p--; res.pop_back();}
    p++;
    res.push_back(inp[i]);     
   }
 res.pop_back();
 
 for(int i=0;i<res.size();i++)
     used[res[i].ind]=1;
 
 if(used[ind]) {found=1;return;}

 inp.clear();
 for(int i=0;i<n;i++)
     if(!used[i]) inp.push_back(work[i]);
}

int main()
{
 init();   
 while(!found) { convexHull(); }   
 
 cout<<depth<<endl;

 return 0;   
}
