// Ivailo Alexandrov Karamanolev

#include <cstdio>
#include <algorithm>
#include <cstring>
using namespace std;

struct point {
	int x, y;
	
	bool operator== (const point& a) const {
		return a.x == x && a.y == y;
	}
} points[16384], oldpoints[16384];
int pointsn, oldpointsn;

point pstack[16384], searchp;
int pstackn;

inline int tarea(point a, point b, point c) {
	return a.x*(b.y - c.y) + b.x*(c.y - a.y) + c.x*(a.y - b.y);
}

bool cmp(const point& a, const point& b) {
	int area = tarea(points[0], a, b);
	if(area > 0)
		return true;
	else if(area < 0)
		return false;
	else
		if((a.x-points[0].x)*(a.x-points[0].x)+(a.y-points[0].y)*(a.y-points[0].y) <
			(b.x-points[0].x)*(b.x-points[0].x)+(b.y-points[0].y)*(b.y-points[0].y))
			return true;
	return false;
}

bool hull[2048][2048];

bool graham() {
	int origin = 0;
	for(int i = 1; i < pointsn; ++i) {
		if(points[i].x < points[origin].x || (points[i].x == points[origin].x && points[i].y < points[origin].y)) {
			origin = i;
		}
	}
	point p = points[0]; points[0] = points[origin]; points[origin] = p;
	sort(points+1, points+pointsn, cmp);
	pstack[0] = points[0];
	pstack[1] = points[1];
	pstackn = 2;
	
	if(pointsn > 2) {
		for(int i = 2; i < pointsn; ++i) {
			while(tarea(pstack[pstackn-2], pstack[pstackn-1], points[i]) < 0)
				--pstackn;
			pstack[pstackn++] = points[i];
		}
		while(tarea(pstack[pstackn-2], pstack[pstackn-1], points[0]) < 0)
			--pstackn;
	}
	
	// done hull
	memset(hull, sizeof(hull), 0);
	for(int i = 0; i < pstackn; ++i)
		hull[pstack[i].x][pstack[i].y] = 1;

	memcpy(oldpoints, points, sizeof(point)*pointsn);
	
	oldpointsn = pointsn;
	pointsn = 0;
	for(int i = 0; i < oldpointsn; ++i)
		if(!hull[oldpoints[i].x][oldpoints[i].y])
			points[pointsn++] = oldpoints[i];
	
	for(int i = 0; i < pointsn; ++i) {
		if(points[i] == searchp)
			return true;
		oldpoints[i] = points[i];
	}
	return false;
}

int main() {
	scanf("%d", &pointsn);
	for(int i = 0; i < pointsn; ++i) {
		scanf("%d%d", &points[i].x, &points[i].y);
		points[i].x += 1024;
		points[i].y += 1024;
	}
	int searchn;
	scanf("%d", &searchn);
	searchp = points[searchn-1];
	
	int depth = 0;
	while(graham()) ++depth;
	printf("%d\n", depth);
	return 0;
}
