// Ivailo Alexandrov Karamanolev

#include <cstdio>
#include <iostream>
#include <queue>
using namespace std;

int m, n;

struct node {
	string name;
	node *left, *right;
	int width;
};

void skip() {
	char c;
	while((c = getc(stdin)) == ' ');
	ungetc(c, stdin);
}

node* read_node() {
	skip();
	getc(stdin);
	skip();
	char c = getc(stdin);
	if(c == ')') return NULL;
	string node_name = "";
	while((c = getc(stdin)) != '"') node_name += c;
	node* ret = new node;
	ret->name = node_name;
	ret->left = read_node();
	ret->right = read_node();
	skip();
	getc(stdin);
	return ret;
}

int width(node* node) {
	int res = 0;
	if(node->left)
		res += width(node->left)+m;
	res += node->name.length()+2;
	if(node->right)
		res += m + width(node->right);
	node->width = res;
	return res;
}

void prints(int s) {
	for(int i = 0; i < s; ++i) putc('_', stdout);
}
void printn(int n) {
	for(int i = 0; i < n; ++i) putc('\n', stdout);
}

#define ROWS 8000
#define COLS 8192

char buffer[ROWS][COLS];
int last[ROWS];

inline int max(int a, int b) { return a >  b ? a : b; }

void dfs(node* nd, int offset, int row) {
	if(nd->left) {
		dfs(nd->left, offset, row+1+n);

		offset += nd->left->width + m;
	}
	
	buffer[row][offset] = '\"';
	memcpy(buffer[row]+offset+1, nd->name.c_str(), nd->name.length());
	buffer[row][offset+1+nd->name.length()] = '\"';
	last[row] = max(last[row], offset+1+nd->name.length()+1);
	
	offset += nd->name.length()+2;
	
	if(nd->right) {
		offset += m;
		dfs(nd->right, offset, row+1+n);
	}
}

int main() {
	node* root = read_node();
	scanf("%d%d", &m, &n);
	width(root);
	
	memset(buffer, ' ', sizeof(buffer));
	
	dfs(root, 0, 0);
	
	for(int i = 0; i < ROWS; i += n+1) {
		if(i > 0)
			for(int j = 0; j < n; ++j) printf("\n");
		
		buffer[i][last[i]] = 0;
		printf("%s\n", buffer[i]);
		
		if(last[i+n+1] == 0) break;
	}
	return 0;
}
